﻿using System.ComponentModel;

namespace RadioButtonGroupTest.Data
{
    public class DataItem : INotifyPropertyChanged
    {
        #region constructor

        public DataItem(string name)
        {
            Name = name;
        }

        #endregion

        #region Name (Public Property)

        private string _name = string.Empty;
        public string Name
        {
            get { return _name; }
            set
            {
                if (value != _name)
                {
                    _name = value;
                    RaisePropertyChanged("Name");
                }
            }
        }

        #endregion

        #region INotifyPropertyChanged Members

        public event PropertyChangedEventHandler PropertyChanged;
        protected void RaisePropertyChanged(string name)
        {
            if (PropertyChanged != null)
                PropertyChanged(this, new PropertyChangedEventArgs(name));
        }

        #endregion
    }
}
