﻿using System.ComponentModel;
using RadioButtonGroupTest.Data;

namespace RadioButtonGroupTest.Data
{
    public class PageViewModel : INotifyPropertyChanged
    {
        #region constructor

        private PageViewModel()
        {
            LoadData();
        }

        #endregion

        #region Instance (Public Static Property)

        private static PageViewModel _instance = null;
        public static PageViewModel Instance
        {
            get
            {
                if (_instance == null)
                {
                    _instance = new PageViewModel();
                }

                return _instance;
            }
        }

        #endregion

        #region Data1 (Public Property)

        private DataCollection _data1;
        public DataCollection Data1
        {
            get { return _data1; }
            set
            {
                if (value != _data1)
                {
                    if ((_data1 != null) && (_data1.Count > 0))
                        _data1.Clear();
                    _data1 = value;
                    RaisePropertyChanged("Data1");
                }
            }
        }

        #endregion

        #region DataA (Public Property)

        private DataCollection _dataA;
        public DataCollection DataA
        {
            get { return _dataA; }
            set
            {
                if (value != _dataA)
                {
                    if ((_dataA != null) && (_dataA.Count > 0))
                        _dataA.Clear();
                    _dataA = value;
                    RaisePropertyChanged("DataA");
                }
            }
        }

        #endregion

        #region LoadData (private method)
        private void LoadData()
        {
            DataCollection data = new DataCollection();
            data = new DataCollection();
            data.Add(new DataItem("1"));
            data.Add(new DataItem("2"));
            data.Add(new DataItem("4"));
            data.Add(new DataItem("8"));
            Data1 = data;

            data = new DataCollection();
            data.Add(new DataItem("A"));
            data.Add(new DataItem("B"));
            data.Add(new DataItem("C"));
            data.Add(new DataItem("D"));
            DataA = data;

        }

        #endregion

        #region INotifyPropertyChanged Members

        public event PropertyChangedEventHandler PropertyChanged;
        protected void RaisePropertyChanged(string name)
        {
            if (PropertyChanged != null)
                PropertyChanged(this, new PropertyChangedEventArgs(name));
        }

        #endregion
    }
}
